/***************************************************************************
 *                                                                         *
 *                               RasTop                                    *
 *                                                                         *
 *  Version:   1.3 based on RasMol 2.7.1                                   *
 *  ========   June 1st, 2000                                              *
 *                                                                         *
 *  Author:    Philippe Valadon                                            *
 *  =======                                                                *
 *                                                                         *
 *  RasTop is an interactive software to visualize molecular structures    *
 *  based on RasMol Molecular Visualization Tool scripting code. RasTop    *
 *  wraps a friendly graphic interface around RasMol core engine and is    *
 *  intended to promote the use of RasMol as a langage to communicate,     *
 *  transfert, exchange information or teaching purpose among the          *
 *  scientific community.                                                  *
 *                                                                         *
 *  RasTop source is distributed freely. Before using RasTop, contributing *
 *  to the source, or using any of its material, you must read and comply  *
 *  with the NOTICE located in the Help folder of RasTop 1.3 package.      *
 *  The NOTICE applies to RasTop 1.3 as a whole and to the works included  *
 *  within it.                                                             *
 *                                                                         *
 *  Copyrights:                                                            *
 *  ==========                                                             *
 *  RasTop                                                                 *
 *  ------                                                                 *
 *  RasTop version 1.3, August 2000                                        *
 *  Philippe Valadon, P.O. Box 13014, La Jolla, CA 92039, USA              *
 *  valadon@ix.netcom.com                                                  *
 *  Copyright (C) Philippe Valadon 2000                                    *
 *                                                                         *
 *  RasMol                                                                 *
 *  ------                                                                 *
 *  RasMol 2.6 by Roger Sayle                                              *
 *  Biomolecular Structures Group, Glaxo Wellcome Research & Development,  *
 *  Stevenage, Hertfordshire, UK                                           *
 *  Version 2.6, August 1995, Version 2.6.4, December 1998                 *
 *  Copyright (C) Roger Sayle 1992-1999                                    *
 *                                                                         *
 *  Mods by Arne Mueller                                                   *
 *  Version 2.6x1, May 1998                                                *
 *  Copyright (C) Arne Mueller 1998                                        *
 *                                                                         *
 *  Version 2.7.0, 2.7.1 Mods by Herbert J. Bernstein                      *
 *  Bernstein + Sons, P.O. Box 177, Bellport, NY, USA                      *
 *  yaya@bernstein-plus-sons.com                                           *
 *  2.7.0 March 1999, 2.7.1 June 1999                                      *
 *  Copyright (C) Herbert J. Bernstein 1998-1999                           *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *  If you would like to use major pieces of RasTop in other programs,     *
 *  make modifications to RasTop, or in some other way make what a lawyer  *
 *  would call a "derived work", you are not only permitted to do so, you  *
 *  are encouraged to do so to the condition of respecting the following   *
 *  points:                                                                *
 *   - explain in your documentation how what you did differs              *
 *     from this version of RasTop;                                        *
 *   - make your modified source code available;                           *
 *   - comply with respect to RasTop NOTICE.                               *
 *                                                                         *
 *  Read the full NOTICE for complete information.                         *
 *                                                                         *
 ***************************************************************************/

/////////////////////////////////////////////////////////////////////////////
// dialog.h
/////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_DIALOG_H)
#define AFX_DIALOG_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CDialogSetValue dialog

#define Type_Ident		1
#define Type_Ribbons	2
#define Type_Strands	3
#define Type_Bonds		4
#define Type_Dots		5
#define Type_Radius		6
#define Type_Sphere		7
#define Type_HBonds		8
#define Type_SSBonds	9
#define Type_Trace		10
#define Type_Cartoons	11
#define Type_Renumber	12
#define Type_Within		13
#define Type_CisAngle	14
#define Type_DotSize	15

class CDialogSetValue : public CDialog
{
// Construction
public:
	int m_ValueType;
	CDialogSetValue(CWnd* pParent = NULL); 

// Dialog Data
	//{{AFX_DATA(CDialogSetValue)
	enum { IDD = IDD_DIALOG_SETVALUE };
	int	m_ValueNumber;
	CString m_ValueTex;
	CString	m_TexComment;
	CString	m_TexValue;
	//}}AFX_DATA

// Overrides
	//{{AFX_VIRTUAL(CDialogSetValue)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:
	int IsType_Strands();
	BOOL IsType_Ident();
	BOOL ConvertToTex();

	//{{AFX_MSG(CDialogSetValue)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CDialogSaveFile dialog

class CDialogSaveFile : public CDialog
{
// Construction
public:
	CDialogSaveFile(CWnd* pParent = NULL);  

// Dialog Data
	//{{AFX_DATA(CDialogSaveFile)
	enum { IDD = IDD_SAVE_MOLECULARFILE };
	int		m_Format;
	//}}AFX_DATA

// Overrides
	//{{AFX_VIRTUAL(CDialogSaveFile)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CDialogSaveFile)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CDialogScript dialog

class CDialogScript : public CDialog
{
// Construction
public:
	CDialogScript(CWnd* pParent = NULL);   

// Dialog Data
	//{{AFX_DATA(CDialogScript)
	enum { IDD = IDD_SAVE_SCRIPT };
	int		m_Format;
	BOOL	m_KinemageFlag;
	//}}AFX_DATA


// Overrides
	//{{AFX_VIRTUAL(CDialogScript)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CDialogScript)
	afx_msg void OnClickMolscript();
	afx_msg void OnClickScript();
	afx_msg void OnClickMagedetail();
	afx_msg void OnClickPovray();
	afx_msg void OnClickVmrl();
	afx_msg void OnSavePovray3();
	afx_msg void OnSavePhipsi();
	afx_msg void OnSaveRdf();
	afx_msg void OnSaveRpp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CDialogImage dialog

class CDialogImage : public CDialog
{
// Construction
public:
	CDialogImage(CWnd* pParent = NULL); 

// Dialog Data
	//{{AFX_DATA(CDialogImage)
	enum { IDD = IDD_SAVE_IMAGE };
	int		m_Format;
	BOOL	m_CartoonFlag;
	int		m_SizeX;
	int		m_SizeY;
	//}}AFX_DATA

// Overrides
	//{{AFX_VIRTUAL(CDialogImage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);  
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateVectors();

	//{{AFX_MSG(CDialogImage)
	afx_msg void OnImageEnablevectps();
	afx_msg void OnImageBmp();
	afx_msg void OnImageGif();
	afx_msg void OnImageEpsf();
	afx_msg void OnImageMonops();
	afx_msg void OnImagePpm();
	afx_msg void OnImagePpm2();
	afx_msg void OnImagePict();
	afx_msg void OnImageIris();
	afx_msg void OnImageSunrle();
	afx_msg void OnImageSun();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CEditData

class CEditData : public CRichEditCtrl
{
// Construction
public:
	CEditData();

// Attributes
public:
protected:
	BOOL VirtKeyCtrl;
	CFont SeqFont;
// Operations
public:

// Overrides
	//{{AFX_VIRTUAL(CEditData)
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	void SaveData( CString& str, CString& name );
	void InitDisplay();
	virtual ~CEditData();

protected:
	//{{AFX_MSG(CEditData)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CDialogEditMolecularFile dialog

class CDialogEditMolecularFile : public CDialog
{
// Construction
public:
	CDialogEditMolecularFile(CWnd* pParent = NULL);

// Dialog Data
	//{{AFX_DATA(CDialogEditMolecularFile)
	enum { IDD = IDD_MOLECULAR_FILE };
	CEditData	m_MolecularData;
	CString	m_MoleculeName;
	CString	m_FileFormat;
	BOOL m_ModifiedFlag;
	//}}AFX_DATA

protected:

// Overrides
	//{{AFX_VIRTUAL(CDialogEditMolecularFile)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
protected:

	//{{AFX_MSG(CDialogEditMolecularFile)
	virtual void OnOK();
	afx_msg void OnSave();
	afx_msg void OnProcess();
	afx_msg void OnExport();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CDialogPreference dialog

class CDialogPreference : public CDialog
{
// Construction
public:
	CDialogPreference(CWnd* pParent = NULL);

// Dialog Data
	//{{AFX_DATA(CDialogPreference)
	enum { IDD = IDD_PREFERENCES };
	int		m_ZoomEdit;
	BOOL	m_MouseInsight;
	BOOL	m_MouseQuanta;
	BOOL	m_MouseRasmol;
	BOOL	m_SequenceFalse;
	BOOL	m_SequenceTrue;
	BOOL	m_MouseSybyl;
	BOOL	m_PannelSize;
	CString	m_HelpSource;
	//}}AFX_DATA

public:
// Overrides
	//{{AFX_VIRTUAL(CDialogPreference)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CDialogPreference)
	afx_msg void OnMouseInsight();
	afx_msg void OnMouseQuanta();
	afx_msg void OnMouseRasmol();
	afx_msg void OnMoleculeSeqFalse();
	afx_msg void OnMoleculeSeqTrue();
	afx_msg void OnMouseSybyl();
	afx_msg void OnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CDialogLabel dialog

class CDialogLabel : public CDialog
{
// Construction
public:
	CDialogLabel(CWnd* pParent = NULL); 

// Dialog Data
	//{{AFX_DATA(CDialogLabel)
	enum { IDD = IDD_LABEL_SETTINGS };
	int		m_nFontSize;
	CString	m_sLabelFormat;
	int		m_FontStroke;
	int		m_FontFS;
	//}}AFX_DATA


// Overrides
	//{{AFX_VIRTUAL(CDialogLabel)
	protected:
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:

	//{{AFX_MSG(CDialogLabel)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CDialogSelect dialog

class CDialogSelect : public CDialog
{
// Construction
public:
	CDialogSelect(CWnd* pParent = NULL);  

	int m_nCommand;
// Dialog Data
	//{{AFX_DATA(CDialogSelect)
	enum { IDD = IDD_SELECT_EXPRESSION };
	CEdit	m_EditSelection;
	CString	m_sExpr;
	//}}AFX_DATA

// Overrides
	//{{AFX_VIRTUAL(CDialogSelect)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); 
	//}}AFX_VIRTUAL

// Implementation
protected:
	CToolBar    m_DlgToolBar;

	//{{AFX_MSG(CDialogSelect)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	afx_msg BOOL OnToolTipText(UINT id, NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnNewSelection();
	afx_msg void OnAddSelection();
	afx_msg void OnRemoveSelection();
	afx_msg void OnExtractSelection();
	afx_msg void OnExcludeSelection();
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CDialogCommand dialog

class CDialogCommand : public CDialog
{
// Construction
public:
	CDialogCommand(CWnd* pParent = NULL);

// Dialog Data
	//{{AFX_DATA(CDialogCommand)
	enum { IDD = IDD_DIALOG_COMMAND };
	CEdit	m_EditCommand;
	CString	m_Command;
	//}}AFX_DATA

// Overrides
	//{{AFX_VIRTUAL(CDialogCommand)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CDialogCommand)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CDialogRasMol dialog

#define DLG_INFO	1
#define DLG_SEQ		2
#define DLG_PHIPSI	3
#define DLG_RPP		4
#define DLG_COOR	5
#define DLG_CHN		6
#define DLG_GRP		7
#define DLG_ATM		8
#define DLG_SYM		9

class CDialogRasMol : public CDialog
{
// Construction
public:
	CDialogRasMol(CWnd* pParent = NULL);

// Dialog Data
	//{{AFX_DATA(CDialogRasMol)
	enum { IDD = IDD_DIALOG_SHOW };
	//}}AFX_DATA

// Overrides
	//{{AFX_VIRTUAL(CDialogRasMol)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
public:
	int m_ShowType;

protected:
	CEditData m_Commandline;

	//{{AFX_MSG(CDialogRasMol)
	virtual BOOL OnInitDialog();
	afx_msg void OnSave();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_DIALOG_H)
