/***************************************************************************
 *                                                                         *
 *                               RasTop                                    *
 *                                                                         *
 *  Version:   1.3 based on RasMol 2.7.1                                   *
 *  ========   June 1st, 2000                                              *
 *                                                                         *
 *  Author:    Philippe Valadon                                            *
 *  =======                                                                *
 *                                                                         *
 *  RasTop is an interactive software to visualize molecular structures    *
 *  based on RasMol Molecular Visualization Tool scripting code. RasTop    *
 *  wraps a friendly graphic interface around RasMol core engine and is    *
 *  intended to promote the use of RasMol as a langage to communicate,     *
 *  transfert, exchange information or teaching purpose among the          *
 *  scientific community.                                                  *
 *                                                                         *
 *  RasTop source is distributed freely. Before using RasTop, contributing *
 *  to the source, or using any of its material, you must read and comply  *
 *  with the NOTICE located in the Help folder of RasTop 1.3 package.      *
 *  The NOTICE applies to RasTop 1.3 as a whole and to the works included  *
 *  within it.                                                             *
 *                                                                         *
 *  Copyrights:                                                            *
 *  ==========                                                             *
 *  RasTop                                                                 *
 *  ------                                                                 *
 *  RasTop version 1.3, August 2000                                        *
 *  Philippe Valadon, P.O. Box 13014, La Jolla, CA 92039, USA              *
 *  valadon@ix.netcom.com                                                  *
 *  Copyright (C) Philippe Valadon 2000                                    *
 *                                                                         *
 *  RasMol                                                                 *
 *  ------                                                                 *
 *  RasMol 2.6 by Roger Sayle                                              *
 *  Biomolecular Structures Group, Glaxo Wellcome Research & Development,  *
 *  Stevenage, Hertfordshire, UK                                           *
 *  Version 2.6, August 1995, Version 2.6.4, December 1998                 *
 *  Copyright (C) Roger Sayle 1992-1999                                    *
 *                                                                         *
 *  Mods by Arne Mueller                                                   *
 *  Version 2.6x1, May 1998                                                *
 *  Copyright (C) Arne Mueller 1998                                        *
 *                                                                         *
 *  Version 2.7.0, 2.7.1 Mods by Herbert J. Bernstein                      *
 *  Bernstein + Sons, P.O. Box 177, Bellport, NY, USA                      *
 *  yaya@bernstein-plus-sons.com                                           *
 *  2.7.0 March 1999, 2.7.1 June 1999                                      *
 *  Copyright (C) Herbert J. Bernstein 1998-1999                           *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *  If you would like to use major pieces of RasTop in other programs,     *
 *  make modifications to RasTop, or in some other way make what a lawyer  *
 *  would call a "derived work", you are not only permitted to do so, you  *
 *  are encouraged to do so to the condition of respecting the following   *
 *  points:                                                                *
 *   - explain in your documentation how what you did differs              *
 *     from this version of RasTop;                                        *
 *   - make your modified source code available;                           *
 *   - comply with respect to RasTop NOTICE.                               *
 *                                                                         *
 *  Read the full NOTICE for complete information.                         *
 *                                                                         *
 ***************************************************************************/

//////////////////////////////////////////////////////////////////////
// pannel.h
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANNEL_H__INCLUDED_)

#define AFX_PANNEL_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define IDT_TIMER_0 WM_USER + 200
#define IDT_TIMER_1 IDT_TIMER_0 + 1

/////////////////////////////////////////////////////////////////////////////
// CPannelBar

class CPannelBar : public CDialogBar
{
	DECLARE_DYNAMIC(CPannelBar)
    public:
		CPannelBar();
		virtual ~CPannelBar();

    // Attributes
    public:
		BOOL m_autoStatus;
	    CFont m_FontPannel;
	    CFont m_FontBuddy;

		void ChangeStatusLight(int Status);
		void UpdatePannel();
		void UpdateScrollBars();
	    void KillTimerPannel();
	    void SetTimerPannel();
		void ResetAutoMode();
		void OnAddInfoline(CString& strText);
		virtual BOOL OnInitDialogBar();

    protected:
		BOOL m_InfoTimerStatus;
		CStatic infopointer;
		CBitmap infopointeroff;
		CBitmap infopointeron;
		CEdit m_Infoline;
		CScrollBar m_ScrollX;
		CScrollBar m_ScrollY;
		CScrollBar m_ScrollZ;
		BOOL Shadow_Flag;
		int FontStroke_Flag;
		CButton m_moderotate;
		CButton m_modetranslate;
		CButton m_reset;
		CButton m_modeauto;
		CSliderCtrl m_Slab;
		CSliderCtrl m_Depth;
		CSliderCtrl m_Light;
		CEdit m_BuddySpec;
		CSpinButtonCtrl m_Specular;
		CEdit m_BuddyShade;
		CSpinButtonCtrl m_Shade;
		UINT m_PannelTimerID_0;
		UINT m_PannelTimerID_1;
		double AutoX, AutoY, AutoZ;
		CBitmapButton m_CloseCommandView;
		CStatic m_RasmolStatus;
		CBitmap StatusLight;

		void AppendString(CString str);
		void RefreshView();

	// Operations
	public:
	//{{AFX_VIRTUAL(CPannelBar)
	//}}AFX_VIRTUAL

	BOOL Create(CWnd * pParentWnd, UINT nIDTemplate, UINT nStyle, UINT nID);

	protected:
	//{{AFX_MSG(CPannelBar)
	afx_msg void OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar );
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRotateButton();
	afx_msg void OnTranszoomButton();
	afx_msg void OnAutoButton();
	afx_msg void OnResetButton();
	afx_msg void OnCloseButton();
	afx_msg void OnUpdateCloseButton(CCmdUI *pCmdUI);
	afx_msg void OnSpecularSpin( NMHDR * pNotifyStruct, LRESULT * result );
	afx_msg void OnUpdateSlabSlid(CCmdUI *pCmdUI);
	afx_msg void OnUpdateDepthSlid(CCmdUI *pCmdUI);
	afx_msg void OnUpdateLightSlid(CCmdUI *pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif // !defined(AFX_PANNEL_H__INCLUDED_)

